// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ==  http://www.amdis-fem.org                                              ==
// ==                                                                        ==
// ============================================================================
//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.



/** \file TraverseParallel.h */

#ifndef AMDIS_TRAVERSEPARALLEL_H
#define AMDIS_TRAVERSEPARALLEL_H

#ifdef _OPENMP

#include "OpenMP.h"
#include "Traverse.h"
#include <vector>

namespace AMDiS {

  /** \ingroup Traverse
   * \brief
   */
  class TraverseParallelStack 
  {
  public: 
    TraverseParallelStack(int nThreads = 0, int mode = 0);

    ~TraverseParallelStack();

    ElInfo* traverseFirst(Mesh *mesh, int level, Flag fillFlag);

    ElInfo* traverseNext(ElInfo* elInfoOld);

  private:
    /// Number of threads using the stack in parallel.
    int nThreads;

    int parallelMode;

    std::vector<TraverseStack*> stacks;
  };

}

#endif  // _OPENMP

#endif  // AMDIS_TRAVERSEPARALLEL_H 

